using System.Numerics;
using System.Runtime.InteropServices;
using System.Security;
using System.Text;
using Sharp.Augeas.Test;

namespace Sharp.Augeas
{
    [SuppressUnmanagedCodeSecurity]
    public static unsafe class AugeasExtern
    {
    
        /// <summary>
        /// Used by DllImport to load the native library
        /// </summary>
        /// 
        private const string _libName = "clAugeas";
        
        
        [DllImport(_libName)]
        public static extern IntPtr init_aug(AugSettings settings, int flags);

        [DllImport(_libName)]
        public static extern void close_aug(IntPtr aug);

        [DllImport(_libName)]
        public static extern void free_str(IntPtr str);


        /// <summary>Test calling</summary>
        [DllImport(_libName)]
        public static extern void print_preview(IntPtr augeas, [MarshalAs(UnmanagedType.LPStr)] string matchPath);

        [DllImport(_libName)]
        public static extern void print_tree(IntPtr augeas, [MarshalAs(UnmanagedType.LPStr)] string matchPath);

        [DllImport(_libName)]
        public static extern IntPtr get_tree(IntPtr augeas, [MarshalAs(UnmanagedType.LPStr)] string matchPath);
        
        
        [DllImport(_libName)]
        public static extern IntPtr get_preview(IntPtr augeas, [MarshalAs(UnmanagedType.LPStr)] string matchPath);
        

        [DllImport(_libName)]
        public static extern IntPtr get_node(IntPtr augeas, [MarshalAs(UnmanagedType.LPStr)] string matchPath);
        
        [DllImport(_libName)]
        public static extern int insert_node(IntPtr augeas, [MarshalAs(UnmanagedType.LPStr)] string matchPath, [MarshalAs(UnmanagedType.LPStr)] string label, int before);

        
        [DllImport(_libName)]
        public static extern bool set_node(IntPtr augeas, [MarshalAs(UnmanagedType.LPStr)] string matchPath, [MarshalAs(UnmanagedType.LPStr)] string value);
        
        
        [DllImport(_libName)]
        public static extern int rm_node(IntPtr augeas, [MarshalAs(UnmanagedType.LPStr)] string matchPath);
                
        
        [DllImport(_libName)]
        public static extern bool save(IntPtr augeas);
        
        
        [DllImport(_libName)] 
        public static extern bool load_file(IntPtr augeas, [MarshalAs(UnmanagedType.LPStr)] string filePath);
       
        
        [DllImport(_libName)]
        internal static extern int match(IntPtr augeas, [MarshalAs(UnmanagedType.LPStr)] string matchPath, sbyte*** matches);
        

    }
}