namespace Sharp.Augeas;

public class Node
{
    public string Id;
    public Node Parent;
    public string Path;
    protected readonly Augeas _augeas;

    public Node(Augeas augeas, string path)
    {
        _augeas = augeas;
        Parent = null;
        Path = path;
    }
    public Node(Augeas augeas, Node parent, string path)
    {
        _augeas = augeas;
        Parent = parent;
        Path = path;
    }

    /// <summary>
    /// Write all pending changes to disk. Only files that had any changes made to them are written.
    /// </summary>
    /// <returns></returns>
    public bool Save()
    {
        return _augeas.Save();
    }

}