using System.Text;

namespace Sharp.Augeas
{
    public class SuperNode : Node
    {
        public List<Directive> Directives;
        public List<Argument> Arguments;
        public List<SuperNode> SuperNodes;

        public SuperNode(Augeas augeas, string path, string id) : base(augeas, path)
        {
            Path = path;
            Id = id;
            Directives = new List<Directive>();
            Arguments = new List<Argument>();
            SuperNodes = new List<SuperNode>();
        }

        public Directive GetDirective(string value)
        {
           return Directives.FirstOrDefault(d => d.Value == value, null);
        }

        public void AddArgument(Argument argument)
        {
            argument.Parent = this;
            Arguments.Add(argument);
        }

        public void AddDirective(Directive directive)
        {
            directive.Parent = this;
            Directives.Add(directive);
        }

        public void AddSuperNode(SuperNode superNode)
        {
            superNode.Parent = this;
            SuperNodes.Add(superNode);
        }

        public override string ToString()
        {
            var sb = new StringBuilder($"{Id} ");
            
            foreach (var arg in Arguments)
            {
                sb.Append($"{arg} ");
            }
            
            return sb.ToString().TrimEnd();;
        }
    }
}

